function objDraw(obj){
    if(obj.Id != null){
        if(obj.DrawFlg==null||obj.DrawFlg==true){
            ctx.drawImage(obj.Id,obj.Source.X,obj.Source.Y,obj.Source.W,obj.Source.H,obj.Draw.X,obj.Draw.Y,obj.Draw.W,obj.Draw.H);
        }
    }
}

function fillRectDraw(x,y,w,h,color){    
    ctx.beginPath();
    ctx.fillStyle=color;
    ctx.fillRect(x,y,w,h);
    ctx.fill();
}

function objFillRectDraw(obj){
    if(obj.FillRectColor==null){
        fillRectDraw(obj.X,obj.Y,obj.W,obj.H,"00000050");
    }else{
        fillRectDraw(obj.X,obj.Y,obj.W,obj.H,obj.FillRectColor);
    }
}

function strokeRectDraw(x,y,w,h,color,size){    
    ctx.beginPath();
    ctx.lineWidth=size;
    ctx.strokeStyle=color;
    ctx.strokeRect(x,y,w,h);
    ctx.fill();
}

function objStrokeRectDraw(obj){
    if(obj.LineSize==null){
        obj.LineSize=1;
    }
    if(obj.LineColor==null){
        obj.LineColor="black";
    }
    strokeRectDraw(obj.X,obj.Y,obj.W,obj.H,obj.LineColor,obj.LineSize);
}

function backColorDraw(obj){
    if(obj.R != null){
        if(obj.BackColor != null)obj.CircleColor = obj.BackColor;
        objCircleDraw(obj)
    }else{
        if(obj.BackColor != null)obj.FillRectColor = obj.BackColor;
        objFillRectDraw(obj);
    }
}

function circleDraw(x,y,r,color){
    ctx.beginPath();
    ctx.fillStyle=color;
    ctx.arc(x,y,r,0,360*Math.PI/180,);
    ctx.fill();
}

function objCircleDraw(obj){
    if(obj.CircleColor != null){
        circleDraw(obj.X,obj.Y,obj.R,obj.CircleColor);
    }else{
        circleDraw(obj.X,obj.Y,obj.R,"#00000050");
    }
}

function textDraw(txt,x,y,w,fontSize,fillColor,strokeColor){
    ctx.beginPath();
    ctx.fillStyle=fillColor;
    ctx.strokeStyle=strokeColor;
    ctx.font=fontSize;
    if(strokeColor != null)ctx.strokeText(txt,x,y,w);
    if(fillColor != null)ctx.fillText(txt,x,y,w);
    if(strokeColor != null)ctx.strokeText(txt,x,y,w);
    if(fillColor != null)ctx.fillText(txt,x,y,w);
}

function objTextDraw(type){
    textDraw(type.Text.txt,type.Text.X,type.Text.Y,type.Text.W,type.Text.FontSize,type.Text.FontFillColor,type.Text.FontStrokeColor);
}

function areaFrameDraw(area){
    ctx.beginPath();
    if(area.Frame.LineWid==null){
        ctx.lineWidth=1;
    }else{
        ctx.lineWidth=area.Frame.LineWid;
    }
    if(area.Frame.Color==null){
        ctx.fillSyle="black";
    }else{
        ctx.fillStyle=area.Frame.Color;
    }
    if(area.Frame.Wid==null){area.Frame.Wid=2;}
    ctx.strokeStyle="black";
    ctx.fillRect(area.Frame.X,area.Frame.Y,area.Frame.Wid,area.Frame.H);
    ctx.fillRect(area.Frame.X,area.Frame.Y,area.Frame.W,area.Frame.Wid);
    ctx.fillRect(area.Frame.X,area.Frame.Y+area.Frame.H-area.Frame.Wid,area.Frame.W,area.Frame.Wid);
    ctx.fillRect(area.Frame.X+area.Frame.W-area.Frame.Wid,area.Frame.Y,area.Frame.Wid,area.Frame.H);
    ctx.strokeRect(area.Frame.X,area.Frame.Y,area.Frame.Wid,area.Frame.H);
    ctx.strokeRect(area.Frame.X,area.Frame.Y,area.Frame.W,area.Frame.Wid);
    ctx.strokeRect(area.Frame.X,area.Frame.Y+area.Frame.H-area.Frame.Wid,area.Frame.W,area.Frame.Wid);
    ctx.strokeRect(area.Frame.X+area.Frame.W-area.Frame.Wid,area.Frame.Y,area.Frame.Wid,area.Frame.H);
    ctx.fill();
    ctx.stroke();
}


function SourceXPuls(obj){
    obj.Source.X+=graLength;
}

function SourceXMinus(obj){
    obj.Source.X-=graLength;
}

function SourceYPuls(obj){
    obj.Source.Y+=graLength;
}

function SourceYMinus(obj){
    obj.Source.Y-=graLength;
}

function MouseChangePointer(type){
    if(type.X<mou.X&&mou.X<type.X+type.W&&type.Y<mou.Y&&mou.Y<type.Y+type.H){
        canvas.style.cursor="pointer";
    }
}
function MouseRangeJudge(rangeObj){
    if(rangeObj.R==null){
        if(rangeObj.X<mou.X&&mou.X<rangeObj.X+rangeObj.W&&rangeObj.Y<mou.Y&&mou.Y<rangeObj.Y+rangeObj.H){
            return true;
        }else{
            return false;
        }
    }else{
        if(rangeObj.X-rangeObj.R<mou.X&&mou.X<rangeObj.X+rangeObj.R&&rangeObj.Y-rangeObj.R<mou.Y&&mou.Y<rangeObj.Y+rangeObj.R){
            return true;
        }else{
            return false
        }
    }
}
function TouchLevelJudge(obj){
    let a=false;
    if(obj.LoveLevel==null&&obj.ExciteLevel==null&&obj.EcstasyCount==null){
        a=true;
    }
    if(obj.LoveLevel!=null&&love.Level>obj.LoveLevel){
        a=true;
    }
    if(obj.ExciteLevel!=null&&excite.Level>obj.ExciteLevel){
        a=true;
    }
    if(obj.EcstasyCount!=null&&ecstasy.Count>obj.EcstasyCount){
        a=true;
    }
    return a;
}
function SourceXMaxJudge(obj){
    if(obj.Source.X<obj.Source.W*obj.Constanse.Max){
        return false;
    }else{
        return true;
    }
}
function SourceXMinJudge(obj){
    if(obj.Source.W*0<obj.Source.X){
        return false;
    }else{
        return true;
    }
}
function SourceYMaxJudge(obj){
    if(obj.Source.Y<obj.Source.H*obj.Constanse.Max){
        return false;
    }else{
        return true;
    }
}
function SourceYMinJudge(obj){
    if(obj.Source.H*0<obj.Source.Y){
        return false;
    }else{
        return true;
    }
}

function makeRandom(max,min){
    return Math.floor(Math.random()*(max+1-min)+min);
}
function DragPulsJudge (obj){
    let Puls,Minus;
    let moveUpJudge=function(){if(mou.Y<=dow.Y-obj.DragConstance){return true;}else{return false;};};
    let moveDownJudge=function(){if(dow.Y+obj.DragConstance<=mou.Y){return true;}else{return false;};};
    let moveLeftJudge=function(){if(mou.X<=dow.X-obj.DragConstance){return true;}else{return false;};};
    let moveRightJudge=function(){if(dow.X+obj.DragConstance<=mou.X){return true;}else{return false;};};
    if(obj.DragType == "up"){Puls=moveUpJudge();Minus=moveDownJudge();}
    else if(obj.DragType == "down"){Puls=moveDownJudge();Minus=moveUpJudge();}
    else if(obj.DragType == "left"){Puls=moveLeftJudge();Minus=moveRightJudge();}
    else if(obj.DragType == "right"){Puls=moveRightJudge();Minus=moveLeftJudge();}
    return Puls;
};
function DragMinusJudge (obj){
    let Puls,Minus;
    let moveUpJudge=function(){if(mou.Y<=dow.Y-obj.DragConstance){return true;}else{return false;};};
    let moveDownJudge=function(){if(dow.Y+obj.DragConstance<=mou.Y){return true;}else{return false;};};
    let moveLeftJudge=function(){if(mou.X<=dow.X-obj.DragConstance){return true;}else{return false;};};
    let moveRightJudge=function(){if(dow.X+obj.DragConstance<=mou.X){return true;}else{return false;};};
    if(obj.DragType == "up"){Puls=moveUpJudge();Minus=moveDownJudge();}
    else if(obj.DragType == "down"){Puls=moveDownJudge();Minus=moveUpJudge();}
    else if(obj.DragType == "left"){Puls=moveLeftJudge();Minus=moveRightJudge();}
    else if(obj.DragType == "right"){Puls=moveRightJudge();Minus=moveLeftJudge();}
    return Minus;
}

function DowUpdate () {dow.X=mou.X;dow.Y=mou.Y;}